const { promisify } = require("util");
const chalk = require("chalk");

/**
 * clone代码模板（v1.0.0只拉取github仓库中的微前端·子应用代码模板）
 * @param {string} repo github代码模板仓库地址
 * @param {string} dest 下载到哪个文件夹下
 */
module.exports.gitClone = async function (repo, dest, mode) {
  const download = promisify(require("download-git-repo"));
  // 控制台进度美化插件
  const ora = require("ora");
  const process = ora(`download......${repo}`);
  // 运行进度转轮
  process.start();
  // 这里填写gitee仓库的地址就行
  let gitUrl =
    mode === "ts"
      ? "https://gitee.com/:" + repo + "#v1.0-ts"
      : "https://gitee.com/:" + repo + "#master";
  try {
    await download(gitUrl, dest, { clone: true });
    process.succeed();
    return "ok";
  } catch (err) {
    process.fail();
    return err.message;
  }
};
